unit AVRStandard;

{$mode objfpc}{$H+}
{$goto on}

INTERFACE

Const
  f_CPU = 4000000; //Hertz

Procedure Wait10m(Time:Byte);
Function DigitToValue(InChar:Char): uInt8;

var
  tempInt: Byte;


//#############################################################################    
IMPLEMENTATION

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Waitingtime = Time * 10 Milliseconds
Procedure Wait10m(Time:Byte);
const
  Faktor = 15*f_CPU div 1000000;
label
  outer,inner1,inner2;
var
  tmpByte,tmpByte2: byte;
begin 
 tempInt:= Time;

asm
  lds r20,tempInt
  ldd r20,Time
  outer:	 
    ldi r21, Faktor
    inner1:         ////640*Faktor= 640*15*1 = 9600 Takte/1MHz
      ldi r22,128
      inner2:		    ////5*128 = 640
        nop         //1
        nop         //1
      dec r22       //1
      brne inner2   //2 ////5
    dec r21
    brne inner1 	
  dec r20
  brne outer

end['r20','r21','r22'];
end;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Function DigitToValue(InChar:Char): uInt8;
begin

  if (InChar >= '0') and (InChar <= '9')
  then Result:= ord(InChar) - 30
  else Result:= 0;

end;




//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
end.
